//wcomtest
#define ESC 27
#define STONE_BLACK 1
#include <stdio.h>
#include <iostream>
#include <conio.h>
#include <winsock2.h>
#include <string.h>
using namespace std;

#include "cgfcomlt.h"

int com_port_num;
int my_color;
volatile UINT movecount;
int teban;
int ret;
int x,y;
BOOL endgameflag;

#define START 1
#define GAME_START 2
#define GAME 3
#define GAME_END_PROCESS 4
#define REMOVE_DEAD_STONE 5
#define RESIGN 6
#define GAME_END 7

#define BOARD_SIZE 21

void initial_config(SOCKET s);
void login_server(SOCKET s);
int command_check(char Bufstr[1024], SOCKET s);
int match_config(char request_command[]);
void send_move(SOCKET s, char next_move[]);
int str_to_int(char str_move_x);
char int_to_str(int str_move_x);

struct move_data
{
	char move[8];
	int white_prisoner;
	int black_prisoner;
	int white_time_left;
	int black_time_left;
	int white_byo_yomi;
	int black_byo_yomi;
	char turn;
	int move_number;
};

struct move_data Move;
char name_white[64], name_black[64], mycolor[8], current_turn, next_move[8], first_move[8], dead_stone[8], resign_player[64], NNGS_ID[32];

main(VOID)
{
	HINSTANCE hLib;

	WSADATA wsaData;
	LPHOSTENT lpHost;
	SOCKET s;
	SOCKADDR_IN sockadd;
	int rec_number, command_status, request;
	unsigned int addr;
	char Server_name[256], BufStr[1024], Port_number[8], SendStr[256], ErrStr[256], request_command[128];
	u_short port;
	u_long CmdArg;
	char str_move_x, str_next_x, char_in[32];
	int move_x, move_y, next_x, next_y;

	cout << "CGF go-communication test" << endl;

	printf("****** NNGS Server Configuration ******\n");
	printf("Please input NNGS Server Name ---");
	gets(Server_name);
	printf("Please input NNGS Port Number(Default:9696) ---");
	gets(Port_number);
	if(strcmp(Port_number, "") == 0){
		strcpy(Port_number, "9696");
	}
	port = (u_short)atoi(Port_number);
	printf("Please input your account of NNGS.\n");
	gets(NNGS_ID);

	request = match_config(request_command);

	if(WSAStartup(MAKEWORD(1,1), &wsaData) != 0){
		perror("WSAStartup error \n");
		return -1;
	}


/* Initialize COM PORT */
	hLib = LoadLibrary("cgfcom");
	if(hLib==NULL) {
		cout << "not able to use DLL." << endl;
		return -1;
	}
	initcom = (BOOL(*)(int))GetProcAddress(hLib,"initcom");
	if(initcom <= 0) {
		FreeLibrary(hLib);
		return -1;
	}
	closecom = (BOOL(*)(VOID))GetProcAddress(hLib,"closecom");
	if(closecom <= 0) {
		FreeLibrary(hLib);
		return -1;
	}

	sendxy = (BOOL(*)(int, int))GetProcAddress(hLib,"sendxy");
	if(sendxy <= 0) {
		FreeLibrary(hLib);
		return -1;
	}
	
	receivexy = (BOOL(*)(int *, int *))GetProcAddress(hLib,"receivexy");
	if(receivexy <= 0) {
		FreeLibrary(hLib);
		return -1;
	}
	newgame = (BOOL(*)(int))GetProcAddress(hLib,"newgame");
	if(newgame <= 0) {
		FreeLibrary(hLib);
		return -1;
	}

	cout << "****** COM PORT Configuration ******" << endl;
	cout << "Please input the number of COM PORT: ";
	cin >> com_port_num;
	cout << "Initializing com port....";
	if(!initcom(com_port_num)) {
		cout << "initcom error" << endl;
		return -1;
	}
	cout << "OK" << endl << endl;

	cout << "****** Communication Start with COM PORT Program ******" << endl;
	if(request != 1){
		cout << "Please set up the COM PORT program as WHITE" << endl;
		cout << "After the program starts communication, please hit Enter key!" << endl;
		gets(char_in);
	}
	else{
		cout << "Please set up the COM PORT program as BLACK" << endl;
		cout << "After you hit Enter key, please let the program start communication!" << endl;
		gets(char_in);
	}
	if(!newgame(my_color)) {
		cout << "newgame timeout" << endl;
		closecom();
		FreeLibrary(hLib);
		return -1;
	}
	cout << "Communication with the COM PORT program starts!" << endl;
	if(request == 1){
		do {
			ret = receivexy(&next_x,&next_y);
			if(_kbhit()) if(getch()==ESC) {
				endgameflag = TRUE;
				break;
			}
		} while (!ret);
		if(endgameflag){
			printf("game end\n");
			return 0;
		}
		cout << " x,y = " << next_x << " " << next_y << endl << endl;
		if(next_x == 0 && next_y == 0){
			sprintf(next_move, "Pass");
		}
		else {
			next_y = (BOARD_SIZE - 1) - next_y;
			str_next_x = int_to_str(next_x);
//			printf("%c, %d", str_next_x, next_y);
			sprintf(first_move, "%c%d", str_next_x, next_y);
		}
	}

/* Initialize SOCKET */

	printf("Initializing SOCKET...");

	s = socket(PF_INET, SOCK_STREAM, 0);
	if(s == INVALID_SOCKET){
		perror("can't open socket\n");
		WSACleanup();
		return -2;
	}
	lpHost = gethostbyname(Server_name);
	if(lpHost == NULL){
		addr = inet_addr(Server_name);
		lpHost = gethostbyaddr((char *)&addr, 4, AF_INET);
		sprintf(ErrStr, "can't find %s", Server_name);
		perror(ErrStr);
		WSACleanup();
		return -3;
	}
	memset(&sockadd, 0, sizeof(sockadd));
	sockadd.sin_family = AF_INET;
	sockadd.sin_port = htons(port);
	sockadd.sin_addr = *((LPIN_ADDR)*lpHost->h_addr_list);
	if(connect(s, (PSOCKADDR)&sockadd, sizeof(sockadd)) != 0){
		perror("fail to connect to server socket\n");
		closesocket(s);
		WSACleanup();
		return -4;
	}
	memset(BufStr, '\0', sizeof(BufStr));
	rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
	printf("OK\n");

	printf("Login NNGS\n");

	login_server(s);

	initial_config(s);
	current_turn = 'B';


	CmdArg = 1;
	ioctlsocket(s, FIONBIO, &CmdArg);

	if(request == 1){
		printf("Sending match request\n");
		sprintf(SendStr, "%s\n", request_command);
		rec_number = send(s, SendStr, (int)strlen(SendStr), 0);
	}
	else{
		printf("Waiting match request\n");
	}


	
	while(1){
		memset(BufStr, '\0', sizeof(BufStr));
		rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
		if(rec_number == 0){
			break;
		}
		else if(rec_number != -1){
			BufStr[rec_number] = '\0';
			if(rec_number != 0){
//				printf("%s", BufStr);
				command_status = command_check(BufStr, s);
//				printf("command_status = %d\n", command_status);

// The lower left is the starting point of cordinates of NNGS. 
// :
// 5
// 4
// 3
// 2
// 1
//   A B C D E ....
//
				if(command_status == GAME){
					if(mycolor[0] == current_turn){
						printf("Program ---> NNGS: %s  Time for Black: %d  Time for White: %d\n", Move.move, Move.black_time_left, Move.white_time_left);
					}
					else{
						printf("Program <--- NNGS: %s  Time for Black: %d  Time for White: %d\n", Move.move, Move.black_time_left, Move.white_time_left);
					}
					if(current_turn == 'B'){
						current_turn = 'W';
					}
					else{
						current_turn = 'B';
					}
					if(mycolor[0] == current_turn){
						if(strcmp("Pass", Move.move)==0){
//							printf("Pass\n");
							move_x = 0;
							move_y = 0;
						}
						else {
							sscanf(Move.move, "%c%d", &str_move_x, &move_y);
							move_x = str_to_int(str_move_x);
							move_y = (BOARD_SIZE - 1) - move_y;
						}
//						printf("XXX = %d, YYY = %d\n", move_x, move_y);
						if(!sendxy(move_x,move_y)) {
							cout << "sendxy timeout" << endl;
							closecom();
							FreeLibrary(hLib);
							return -1;
						}
						do {
							ret = receivexy(&next_x,&next_y);
							if(_kbhit()) if(getch()==ESC) {
								endgameflag = TRUE;
								break;
							}
						} while (!ret);
						if(endgameflag) break;
//						cout << " x,y = " << next_x << " " << next_y << endl;
						if(next_x == 0 && next_y == 0){
							sprintf(next_move, "Pass");
						}
						else {
							next_y = (BOARD_SIZE - 1) - next_y;
							str_next_x = int_to_str(next_x);
//							printf("%c, %d", str_next_x, next_y);
							sprintf(next_move, "%c%d", str_next_x, next_y);
						}
						send_move(s, next_move);
					}
				}
				else if(command_status == GAME_START){
					if(mycolor[0] == current_turn){
						send_move(s, first_move);
					}
				}
// Normaly, in the end of the game, both programs send the dead stone information to the server.
// After both players send the dead stone information, both players send "done" to the server,
// and game ends.
				else if(command_status == GAME_END_PROCESS){
					if(mycolor[0] == current_turn){
						printf("Program ---> NNGS: %s  Time for Black: %d  Time for White: %d\n", Move.move, Move.black_time_left, Move.white_time_left);
					}
					else{
						printf("Program <--- NNGS: %s  Time for Black: %d  Time for White: %d\n", Move.move, Move.black_time_left, Move.white_time_left);
					}
					if(mycolor[0] != current_turn){
						move_x = 0;
						move_y = 0;
						if(!sendxy(move_x,move_y)) {
							cout << "sendxy timeout" << endl;
							closecom();
							FreeLibrary(hLib);
							return -1;
						}
					}
//					end_game_process();
					sprintf(SendStr, "done\n");
					rec_number = send(s, SendStr, (int)strlen(SendStr), 0);
					printf("The game is stopped\n");
//					exit(0);
				}
				else if(command_status == REMOVE_DEAD_STONE){
//					remove_dead_stones(dead_stone);//remove dead stones and its string
				}
				else if(command_status == RESIGN){
//					resign_end();
				}
			}
		}

	}
	if(shutdown(s, SD_BOTH) != 0){
		perror("fail to shutdwon\n");
	}
	closesocket(s);
	WSACleanup();
	closecom();
	FreeLibrary(hLib);
	return 0;
	
//	movecount = 0;
//	endgameflag = FALSE;
//	while (TRUE) {
//	movecount++;
//	teban = ((movecount+1) & 1) + 1;
//	cout << "step:" << movecount << endl;
//	closecom();
//	FreeLibrary(hLib);
//	cout << "end of game" << endl;
//	}
}


int command_check(char Bufstr[1024], SOCKET s)
{
	char opponent_player[32], Sendstr[256], opponent_playerb[32];
	int boardsize, byoyomi_setting, time_setting;
	float komi;
	int not_use1, not_use2, not_use3;
	char not_use4[32], not_use5[32], Turn, move_x, tmp[1024], *p;
	int game_number, move_y;

	if(sscanf(Bufstr, "9 Match [%dx%d] in %d minutes requested with %s as %s\n9 Use <match %s %s %d %d %d> or <decline %s> to respond.", &not_use1, &not_use2, &not_use3, not_use4, not_use5, opponent_player, mycolor, &boardsize, &time_setting, &byoyomi_setting, opponent_playerb) >= 11){
		if(mycolor[0] == 'W'){
			sprintf(Sendstr, "match %s %s %d %d %d\n", opponent_player, mycolor, boardsize, time_setting, byoyomi_setting);
			send(s, Sendstr, (int)strlen(Sendstr), 0);
		}
		else{
			sprintf(Sendstr, "decline %s\n", opponent_player);
			send(s, Sendstr, (int)strlen(Sendstr), 0);
			printf("I decline the match request, because the opponent requests as White player.\n");
		}
		return START;
	}

	if(sscanf(Bufstr, "9 Match [%d] with %s in %d accepted.\n1 5\n9 Creating match [%d] with %s\n1 5\n15 Game 1 I: %s (%d %d %d) vs %s (%d %d %d)\n\n", &game_number, not_use4, &not_use1, &not_use2, not_use5, name_white, &Move.white_prisoner, &Move.white_time_left, &Move.white_byo_yomi, name_black, &Move.black_prisoner, &Move.black_time_left, &Move.black_byo_yomi) >= 5){
		if(strstr(Bufstr, "\n1 6")){
			printf("%s vs %s Game Start!\n", name_white, name_black);
			p = strstr(Bufstr, "\n15   0(B):");
			if(p != NULL){
				sprintf(tmp, "%s", (p+1));
				sscanf(tmp, "15   0(B): %s\n", Move.move);
				sscanf(Move.move, "%c%d", &move_x, &move_y);
//				printf("%s\n", Move.move);
				if( !('A' <= move_x && move_x <= 'T' && move_x != 'I')){
					printf("Move Error!\n");
				}
				if( !(0 < move_y && move_y < 20)){
					printf("Move Error!\n");
				}

				return GAME;
			}
			return GAME_START;
		}
	}

	if(sscanf(Bufstr, "15 Game %d I: %s (%d %d %d) vs %s (%d %d %d)\n15 %d(%c): %s\n\n1 6", &game_number, name_white, &Move.white_prisoner, &Move.white_time_left, &Move.white_byo_yomi, name_black, &Move.black_prisoner, &Move.black_time_left, &Move.black_byo_yomi, &Move.move_number, &Turn, Move.move) >= 5 ){
//		printf("%c: %s\n", Turn, Move.move);
		if(strcmp(Move.move, "Pass") != 0){
			sscanf(Move.move, "%c%d", &move_x, &move_y);
			if( !('A' <= move_x && move_x <= 'T' && move_x != 'I')){
				printf("Move Error!\n");
			}
			if( !(0 < move_y && move_y < 20)){
				printf("Move Error!\n");
			}
		}
		return GAME;
	}

	if(strstr(Bufstr, "9 You can check your score with the score command")){
		return GAME_END_PROCESS;
	}
	if(sscanf(Bufstr, "9 Removing @ %s\n1 7", dead_stone) >= 1){
		return REMOVE_DEAD_STONE;
	}
	if(strstr(Bufstr, "resigned the game")){
		sscanf(Bufstr, "9 %s has resigned the game.", resign_player);
		printf("Player %s resigned!\n", resign_player);
		return RESIGN;
	}

	if(strstr(Bufstr, "declines your request for a match")){
		printf("The opponent decline your match request\n");
		exit(0);
	}

	return 0;
}

int match_config(char request_command[])
{
	char char_in[32], o_name[32], time_in[8], byo_in[8], retry[8];
	int request;

	while(1){
		printf("\n****** NNGS Match Configuration ******\n");
		printf("Please chose match style.\n");
		printf("1: COM PORT PROGRAM is BLACK and NNGS opponent is WHITE\n");
		printf("   (I log in the NNGS and send the match request)\n");
		printf("2: COM PORT PROGRAM is WHITE and NNGS opponent is BLACK\n");
		printf("   (I log in the NNGS and wait for the match request)\n");
		gets(char_in);
		if(strcmp(char_in, "1") == 0){
			sprintf(mycolor, "B");
			my_color = 2;
			request = 1;
			printf("Please input Opponent User Name of NNGS\n");
			gets(o_name);
			printf("Please input the Time.(Default: 40)\n");
			gets(time_in);
			if(strcmp(time_in, "") == 0){
				strcpy(time_in, "40");
			}
			printf("Please input Byo-Yomi.(Default: 0)\n");
			gets(byo_in);
			if(strcmp(byo_in, "") == 0){
				strcpy(byo_in, "0");
			}
			sprintf(request_command, "match %s %s 19 %s %s", o_name, mycolor, time_in, byo_in);
			printf("your match request is [%s]. Is it OK?\n1: OK 2: NO\n", request_command);
			gets(retry);
			if(strcmp(retry, "1") != 0){
				continue;
			}
		}
		else{
			sprintf(mycolor, "W");
			my_color = 1;
			request = 0;
		}
		return request;
	}

}

void login_server(SOCKET s)
{
	char BufStr[1024], SendStr[256], ErrStr[256];
	int rec_number;

	if(strcmp(BufStr, "Login:") != 0){
		sprintf(SendStr, "%s\n", NNGS_ID);
		send(s, SendStr, (int)strlen(SendStr), 0);
		memset(BufStr, '\0', sizeof(BufStr));
		rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//		printf("%s", BufStr);
		if(strstr(BufStr, "\n1 1")){
			printf("Please input your password.\n");
			gets(SendStr);
			sprintf(SendStr, "%s\n", SendStr);
			rec_number = send(s, SendStr, (int)strlen(SendStr), 0);
			memset(BufStr, '\0', sizeof(BufStr));
			rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//			printf("%s", BufStr);
		}
		else if(strncmp(&BufStr[2], "Password:", 9) == 0){
			printf("Please input your password.\n");
			gets(SendStr);
			sprintf(SendStr, "%s\n", SendStr);
			send(s, SendStr, (int)strlen(SendStr), 0);
			memset(BufStr, '\0', sizeof(BufStr));
			rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//			printf("%s", BufStr);
		}
		if(strstr(BufStr, "#>") || strstr(BufStr, "\n1 5")){
			printf("Login Success!\n");
		}
	}

}

void initial_config(SOCKET s)
{
	char BufStr[1024], SendStr[256], ErrStr[256];
	int rec_number;

	sprintf(SendStr, "toggle client TRUE\n");
	send(s, SendStr, (int)strlen(SendStr), 0);
//	printf("%s", SendStr);
	memset(BufStr, '\0', sizeof(BufStr));
	rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//	printf("%s", BufStr);

	sprintf(SendStr, "toggle bell FALSE\n");
	send(s, SendStr, (int)strlen(SendStr), 0);
	memset(BufStr, '\0', sizeof(BufStr));
	rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//	printf("%s", BufStr);

	sprintf(SendStr, "toggle automail FALSE\n");
	send(s, SendStr, (int)strlen(SendStr), 0);
	memset(BufStr, '\0', sizeof(BufStr));
	rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//	printf("%s", BufStr);

	sprintf(SendStr, "set pin FALSE\n");
	send(s, SendStr, (int)strlen(SendStr), 0);
	memset(BufStr, '\0', sizeof(BufStr));
	rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//	printf("%s", BufStr);

	sprintf(SendStr, "set gin FALSE\n");
	send(s, SendStr, (int)strlen(SendStr), 0);
	memset(BufStr, '\0', sizeof(BufStr));
	rec_number = recv(s, BufStr, (int)sizeof(BufStr) - 1, 0);
//	printf("%s", BufStr);
}

void send_move(SOCKET s, char next_move[])
{
	char SendStr[256], ErrStr[256];

	sprintf(SendStr, "%s\n", next_move);
	send(s, SendStr, (int)strlen(SendStr), 0);
}

int str_to_int(char str_move_x)
{

	switch(str_move_x){
	case 'A':
		return 1;
	case 'B':
		return 2;
	case 'C':
		return 3;
	case 'D':
		return 4;
	case 'E':
		return 5;
	case 'F':
		return 6;
	case 'G':
		return 7;
	case 'H':
		return 8;
	case 'J':
		return 9;
	case 'K':
		return 10;
	case 'L':
		return 11;
	case 'M':
		return 12;
	case 'N':
		return 13;
	case 'O':
		return 14;
	case 'P':
		return 15;
	case 'Q':
		return 16;
	case 'R':
		return 17;
	case 'S':
		return 18;
	case 'T':
		return 19;
	default:
		return 0;
	}
}

char int_to_str(int str_move_x)
{

	switch(str_move_x){
	case 1:
		return 'A';
	case 2:
		return 'B';
	case 3:
		return 'C';
	case 4:
		return 'D';
	case 5:
		return 'E';
	case 6:
		return 'F';
	case 7:
		return 'G';
	case 8:
		return 'H';
	case 9:
		return 'J';
	case 10:
		return 'K';
	case 11:
		return 'L';
	case 12:
		return 'M';
	case 13:
		return 'N';
	case 14:
		return 'O';
	case 15:
		return 'P';
	case 16:
		return 'Q';
	case 17:
		return 'R';
	case 18:
		return 'S';
	case 19:
		return 'T';
	default:
		return 'U';
	}
}

